<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">


<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    
    <title>15.1. hashlib — Secure hashes and message digests &mdash; Python 3.5.1 documentation</title>
    
    <link rel="stylesheet" href="../_static/pydoctheme.css" type="text/css" />
    <link rel="stylesheet" href="../_static/pygments.css" type="text/css" />
    
    <script type="text/javascript">
      var DOCUMENTATION_OPTIONS = {
        URL_ROOT:    '../',
        VERSION:     '3.5.1',
        COLLAPSE_INDEX: false,
        FILE_SUFFIX: '.html',
        HAS_SOURCE:  true
      };
    </script>
    <script type="text/javascript" src="../_static/jquery.js"></script>
    <script type="text/javascript" src="../_static/underscore.js"></script>
    <script type="text/javascript" src="../_static/doctools.js"></script>
    <script type="text/javascript" src="../_static/sidebar.js"></script>
    <link rel="search" type="application/opensearchdescription+xml"
          title="Search within Python 3.5.1 documentation"
          href="../_static/opensearch.xml"/>
    <link rel="author" title="About these documents" href="../about.html" />
    <link rel="copyright" title="Copyright" href="../copyright.html" />
    <link rel="top" title="Python 3.5.1 documentation" href="../contents.html" />
    <link rel="up" title="15. Cryptographic Services" href="crypto.html" />
    <link rel="next" title="15.2. hmac — Keyed-Hashing for Message Authentication" href="hmac.html" />
    <link rel="prev" title="15. Cryptographic Services" href="crypto.html" />
    <link rel="shortcut icon" type="image/png" href="../_static/py.png" />
    <script type="text/javascript" src="../_static/copybutton.js"></script>
    <script type="text/javascript" src="../_static/version_switch.js"></script>
    
 

  </head>
  <body role="document">  
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="../py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="right" >
          <a href="hmac.html" title="15.2. hmac — Keyed-Hashing for Message Authentication"
             accesskey="N">next</a> |</li>
        <li class="right" >
          <a href="crypto.html" title="15. Cryptographic Services"
             accesskey="P">previous</a> |</li>
        <li><img src="../_static/py.png" alt=""
                 style="vertical-align: middle; margin-top: -1px"/></li>
        <li><a href="https://www.python.org/">Python</a> &raquo;</li>
        <li>
          <span class="version_switcher_placeholder">3.5.1</span>
          <a href="../index.html">Documentation</a> &raquo;
        </li>

          <li class="nav-item nav-item-1"><a href="index.html" >The Python Standard Library</a> &raquo;</li>
          <li class="nav-item nav-item-2"><a href="crypto.html" accesskey="U">15. Cryptographic Services</a> &raquo;</li> 
      </ul>
    </div>    

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <div class="section" id="module-hashlib">
<span id="hashlib-secure-hashes-and-message-digests"></span><h1>15.1. <a class="reference internal" href="#module-hashlib" title="hashlib: Secure hash and message digest algorithms."><code class="xref py py-mod docutils literal"><span class="pre">hashlib</span></code></a> &#8212; Secure hashes and message digests<a class="headerlink" href="#module-hashlib" title="Permalink to this headline">¶</a></h1>
<p id="index-0"><strong>Source code:</strong> <a class="reference external" href="https://hg.python.org/cpython/file/3.5/Lib/hashlib.py">Lib/hashlib.py</a></p>
<hr class="docutils" />
<p>This module implements a common interface to many different secure hash and
message digest algorithms.  Included are the FIPS secure hash algorithms SHA1,
SHA224, SHA256, SHA384, and SHA512 (defined in FIPS 180-2) as well as RSA&#8217;s MD5
algorithm (defined in Internet <span class="target" id="index-1"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc1321.html"><strong>RFC 1321</strong></a>).  The terms &#8220;secure hash&#8221; and
&#8220;message digest&#8221; are interchangeable.  Older algorithms were called message
digests.  The modern term is secure hash.</p>
<div class="admonition note">
<p class="first admonition-title">Note</p>
<p class="last">If you want the adler32 or crc32 hash functions, they are available in
the <a class="reference internal" href="zlib.html#module-zlib" title="zlib: Low-level interface to compression and decompression routines compatible with gzip."><code class="xref py py-mod docutils literal"><span class="pre">zlib</span></code></a> module.</p>
</div>
<div class="admonition warning">
<p class="first admonition-title">Warning</p>
<p class="last">Some algorithms have known hash collision weaknesses, refer to the &#8220;See
also&#8221; section at the end.</p>
</div>
<div class="section" id="hash-algorithms">
<span id="id1"></span><h2>15.1.1. Hash algorithms<a class="headerlink" href="#hash-algorithms" title="Permalink to this headline">¶</a></h2>
<p>There is one constructor method named for each type of <em class="dfn">hash</em>.  All return
a hash object with the same simple interface. For example: use <code class="xref py py-func docutils literal"><span class="pre">sha1()</span></code> to
create a SHA1 hash object. You can now feed this object with <a class="reference internal" href="../glossary.html#term-bytes-like-object"><span class="xref std std-term">bytes-like
object</span></a>s (normally <a class="reference internal" href="functions.html#bytes" title="bytes"><code class="xref py py-class docutils literal"><span class="pre">bytes</span></code></a>) using the <code class="xref py py-meth docutils literal"><span class="pre">update()</span></code> method.
At any point you can ask it for the <em class="dfn">digest</em> of the
concatenation of the data fed to it so far using the <code class="xref py py-meth docutils literal"><span class="pre">digest()</span></code> or
<code class="xref py py-meth docutils literal"><span class="pre">hexdigest()</span></code> methods.</p>
<div class="admonition note">
<p class="first admonition-title">Note</p>
<p class="last">For better multithreading performance, the Python <a class="reference internal" href="../glossary.html#term-gil"><span class="xref std std-term">GIL</span></a> is released for
data larger than 2047 bytes at object creation or on update.</p>
</div>
<div class="admonition note">
<p class="first admonition-title">Note</p>
<p class="last">Feeding string objects into <code class="xref py py-meth docutils literal"><span class="pre">update()</span></code> is not supported, as hashes work
on bytes, not on characters.</p>
</div>
<p id="index-2">Constructors for hash algorithms that are always present in this module are
<code class="xref py py-func docutils literal"><span class="pre">md5()</span></code>, <code class="xref py py-func docutils literal"><span class="pre">sha1()</span></code>, <code class="xref py py-func docutils literal"><span class="pre">sha224()</span></code>, <code class="xref py py-func docutils literal"><span class="pre">sha256()</span></code>, <code class="xref py py-func docutils literal"><span class="pre">sha384()</span></code>,
and <code class="xref py py-func docutils literal"><span class="pre">sha512()</span></code>. Additional algorithms may also be available depending upon
the OpenSSL library that Python uses on your platform.</p>
<p>For example, to obtain the digest of the byte string <code class="docutils literal"><span class="pre">b'Nobody</span> <span class="pre">inspects</span> <span class="pre">the</span>
<span class="pre">spammish</span> <span class="pre">repetition'</span></code>:</p>
<div class="highlight-python3"><div class="highlight"><pre><span class="gp">&gt;&gt;&gt; </span><span class="kn">import</span> <span class="nn">hashlib</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">m</span> <span class="o">=</span> <span class="n">hashlib</span><span class="o">.</span><span class="n">md5</span><span class="p">()</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">m</span><span class="o">.</span><span class="n">update</span><span class="p">(</span><span class="n">b</span><span class="s">&quot;Nobody inspects&quot;</span><span class="p">)</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">m</span><span class="o">.</span><span class="n">update</span><span class="p">(</span><span class="n">b</span><span class="s">&quot; the spammish repetition&quot;</span><span class="p">)</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">m</span><span class="o">.</span><span class="n">digest</span><span class="p">()</span>
<span class="go">b&#39;\xbbd\x9c\x83\xdd\x1e\xa5\xc9\xd9\xde\xc9\xa1\x8d\xf0\xff\xe9&#39;</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">m</span><span class="o">.</span><span class="n">digest_size</span>
<span class="go">16</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">m</span><span class="o">.</span><span class="n">block_size</span>
<span class="go">64</span>
</pre></div>
</div>
<p>More condensed:</p>
<div class="highlight-python3"><div class="highlight"><pre><span class="gp">&gt;&gt;&gt; </span><span class="n">hashlib</span><span class="o">.</span><span class="n">sha224</span><span class="p">(</span><span class="n">b</span><span class="s">&quot;Nobody inspects the spammish repetition&quot;</span><span class="p">)</span><span class="o">.</span><span class="n">hexdigest</span><span class="p">()</span>
<span class="go">&#39;a4337bc45a8fc544c03f52dc550cd6e1e87021bc896588bd79e901e2&#39;</span>
</pre></div>
</div>
<dl class="function">
<dt id="hashlib.new">
<code class="descclassname">hashlib.</code><code class="descname">new</code><span class="sig-paren">(</span><em>name</em><span class="optional">[</span>, <em>data</em><span class="optional">]</span><span class="sig-paren">)</span><a class="headerlink" href="#hashlib.new" title="Permalink to this definition">¶</a></dt>
<dd><p>Is a generic constructor that takes the string name of the desired
algorithm as its first parameter.  It also exists to allow access to the
above listed hashes as well as any other algorithms that your OpenSSL
library may offer.  The named constructors are much faster than <a class="reference internal" href="#hashlib.new" title="hashlib.new"><code class="xref py py-func docutils literal"><span class="pre">new()</span></code></a>
and should be preferred.</p>
</dd></dl>

<p>Using <a class="reference internal" href="#hashlib.new" title="hashlib.new"><code class="xref py py-func docutils literal"><span class="pre">new()</span></code></a> with an algorithm provided by OpenSSL:</p>
<div class="highlight-python3"><div class="highlight"><pre><span class="gp">&gt;&gt;&gt; </span><span class="n">h</span> <span class="o">=</span> <span class="n">hashlib</span><span class="o">.</span><span class="n">new</span><span class="p">(</span><span class="s">&#39;ripemd160&#39;</span><span class="p">)</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">h</span><span class="o">.</span><span class="n">update</span><span class="p">(</span><span class="n">b</span><span class="s">&quot;Nobody inspects the spammish repetition&quot;</span><span class="p">)</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">h</span><span class="o">.</span><span class="n">hexdigest</span><span class="p">()</span>
<span class="go">&#39;cc4a5ce1b3df48aec5d22d1f16b894a0b894eccc&#39;</span>
</pre></div>
</div>
<p>Hashlib provides the following constant attributes:</p>
<dl class="data">
<dt id="hashlib.algorithms_guaranteed">
<code class="descclassname">hashlib.</code><code class="descname">algorithms_guaranteed</code><a class="headerlink" href="#hashlib.algorithms_guaranteed" title="Permalink to this definition">¶</a></dt>
<dd><p>A set containing the names of the hash algorithms guaranteed to be supported
by this module on all platforms.</p>
<div class="versionadded">
<p><span class="versionmodified">New in version 3.2.</span></p>
</div>
</dd></dl>

<dl class="data">
<dt id="hashlib.algorithms_available">
<code class="descclassname">hashlib.</code><code class="descname">algorithms_available</code><a class="headerlink" href="#hashlib.algorithms_available" title="Permalink to this definition">¶</a></dt>
<dd><p>A set containing the names of the hash algorithms that are available in the
running Python interpreter.  These names will be recognized when passed to
<a class="reference internal" href="#hashlib.new" title="hashlib.new"><code class="xref py py-func docutils literal"><span class="pre">new()</span></code></a>.  <a class="reference internal" href="#hashlib.algorithms_guaranteed" title="hashlib.algorithms_guaranteed"><code class="xref py py-attr docutils literal"><span class="pre">algorithms_guaranteed</span></code></a> will always be a subset.  The
same algorithm may appear multiple times in this set under different names
(thanks to OpenSSL).</p>
<div class="versionadded">
<p><span class="versionmodified">New in version 3.2.</span></p>
</div>
</dd></dl>

<p>The following values are provided as constant attributes of the hash objects
returned by the constructors:</p>
<dl class="data">
<dt id="hashlib.hash.digest_size">
<code class="descclassname">hash.</code><code class="descname">digest_size</code><a class="headerlink" href="#hashlib.hash.digest_size" title="Permalink to this definition">¶</a></dt>
<dd><p>The size of the resulting hash in bytes.</p>
</dd></dl>

<dl class="data">
<dt id="hashlib.hash.block_size">
<code class="descclassname">hash.</code><code class="descname">block_size</code><a class="headerlink" href="#hashlib.hash.block_size" title="Permalink to this definition">¶</a></dt>
<dd><p>The internal block size of the hash algorithm in bytes.</p>
</dd></dl>

<p>A hash object has the following attributes:</p>
<dl class="attribute">
<dt id="hashlib.hash.name">
<code class="descclassname">hash.</code><code class="descname">name</code><a class="headerlink" href="#hashlib.hash.name" title="Permalink to this definition">¶</a></dt>
<dd><p>The canonical name of this hash, always lowercase and always suitable as a
parameter to <a class="reference internal" href="#hashlib.new" title="hashlib.new"><code class="xref py py-func docutils literal"><span class="pre">new()</span></code></a> to create another hash of this type.</p>
<div class="versionchanged">
<p><span class="versionmodified">Changed in version 3.4: </span>The name attribute has been present in CPython since its inception, but
until Python 3.4 was not formally specified, so may not exist on some
platforms.</p>
</div>
</dd></dl>

<p>A hash object has the following methods:</p>
<dl class="method">
<dt id="hashlib.hash.update">
<code class="descclassname">hash.</code><code class="descname">update</code><span class="sig-paren">(</span><em>arg</em><span class="sig-paren">)</span><a class="headerlink" href="#hashlib.hash.update" title="Permalink to this definition">¶</a></dt>
<dd><p>Update the hash object with the object <em>arg</em>, which must be interpretable as
a buffer of bytes.  Repeated calls are equivalent to a single call with the
concatenation of all the arguments: <code class="docutils literal"><span class="pre">m.update(a);</span> <span class="pre">m.update(b)</span></code> is
equivalent to <code class="docutils literal"><span class="pre">m.update(a+b)</span></code>.</p>
<div class="versionchanged">
<p><span class="versionmodified">Changed in version 3.1: </span>The Python GIL is released to allow other threads to run while hash
updates on data larger than 2047 bytes is taking place when using hash
algorithms supplied by OpenSSL.</p>
</div>
</dd></dl>

<dl class="method">
<dt id="hashlib.hash.digest">
<code class="descclassname">hash.</code><code class="descname">digest</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#hashlib.hash.digest" title="Permalink to this definition">¶</a></dt>
<dd><p>Return the digest of the data passed to the <a class="reference internal" href="#hashlib.hash.update" title="hashlib.hash.update"><code class="xref py py-meth docutils literal"><span class="pre">update()</span></code></a> method so far.
This is a bytes object of size <a class="reference internal" href="#hashlib.hash.digest_size" title="hashlib.hash.digest_size"><code class="xref py py-attr docutils literal"><span class="pre">digest_size</span></code></a> which may contain bytes in
the whole range from 0 to 255.</p>
</dd></dl>

<dl class="method">
<dt id="hashlib.hash.hexdigest">
<code class="descclassname">hash.</code><code class="descname">hexdigest</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#hashlib.hash.hexdigest" title="Permalink to this definition">¶</a></dt>
<dd><p>Like <a class="reference internal" href="#hashlib.hash.digest" title="hashlib.hash.digest"><code class="xref py py-meth docutils literal"><span class="pre">digest()</span></code></a> except the digest is returned as a string object of
double length, containing only hexadecimal digits.  This may be used to
exchange the value safely in email or other non-binary environments.</p>
</dd></dl>

<dl class="method">
<dt id="hashlib.hash.copy">
<code class="descclassname">hash.</code><code class="descname">copy</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#hashlib.hash.copy" title="Permalink to this definition">¶</a></dt>
<dd><p>Return a copy (&#8220;clone&#8221;) of the hash object.  This can be used to efficiently
compute the digests of data sharing a common initial substring.</p>
</dd></dl>

</div>
<div class="section" id="key-derivation">
<h2>15.1.2. Key derivation<a class="headerlink" href="#key-derivation" title="Permalink to this headline">¶</a></h2>
<p>Key derivation and key stretching algorithms are designed for secure password
hashing. Naive algorithms such as <code class="docutils literal"><span class="pre">sha1(password)</span></code> are not resistant against
brute-force attacks. A good password hashing function must be tunable, slow, and
include a <a class="reference external" href="https://en.wikipedia.org/wiki/Salt_%28cryptography%29">salt</a>.</p>
<dl class="function">
<dt id="hashlib.pbkdf2_hmac">
<code class="descclassname">hashlib.</code><code class="descname">pbkdf2_hmac</code><span class="sig-paren">(</span><em>name</em>, <em>password</em>, <em>salt</em>, <em>rounds</em>, <em>dklen=None</em><span class="sig-paren">)</span><a class="headerlink" href="#hashlib.pbkdf2_hmac" title="Permalink to this definition">¶</a></dt>
<dd><p>The function provides PKCS#5 password-based key derivation function 2. It
uses HMAC as pseudorandom function.</p>
<p>The string <em>name</em> is the desired name of the hash digest algorithm for
HMAC, e.g. &#8216;sha1&#8217; or &#8216;sha256&#8217;. <em>password</em> and <em>salt</em> are interpreted as
buffers of bytes. Applications and libraries should limit <em>password</em> to
a sensible value (e.g. 1024). <em>salt</em> should be about 16 or more bytes from
a proper source, e.g. <a class="reference internal" href="os.html#os.urandom" title="os.urandom"><code class="xref py py-func docutils literal"><span class="pre">os.urandom()</span></code></a>.</p>
<p>The number of <em>rounds</em> should be chosen based on the hash algorithm and
computing power. As of 2013, at least 100,000 rounds of SHA-256 is suggested.</p>
<p><em>dklen</em> is the length of the derived key. If <em>dklen</em> is <code class="docutils literal"><span class="pre">None</span></code> then the
digest size of the hash algorithm <em>name</em> is used, e.g. 64 for SHA-512.</p>
<div class="highlight-python3"><div class="highlight"><pre><span class="gp">&gt;&gt;&gt; </span><span class="kn">import</span> <span class="nn">hashlib</span><span class="o">,</span> <span class="nn">binascii</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">dk</span> <span class="o">=</span> <span class="n">hashlib</span><span class="o">.</span><span class="n">pbkdf2_hmac</span><span class="p">(</span><span class="s">&#39;sha256&#39;</span><span class="p">,</span> <span class="n">b</span><span class="s">&#39;password&#39;</span><span class="p">,</span> <span class="n">b</span><span class="s">&#39;salt&#39;</span><span class="p">,</span> <span class="mi">100000</span><span class="p">)</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">binascii</span><span class="o">.</span><span class="n">hexlify</span><span class="p">(</span><span class="n">dk</span><span class="p">)</span>
<span class="go">b&#39;0394a2ede332c9a13eb82e9b24631604c31df978b4e2f0fbd2c549944f9d79a5&#39;</span>
</pre></div>
</div>
<div class="versionadded">
<p><span class="versionmodified">New in version 3.4.</span></p>
</div>
<div class="admonition note">
<p class="first admonition-title">Note</p>
<p class="last">A fast implementation of <em>pbkdf2_hmac</em> is available with OpenSSL.  The
Python implementation uses an inline version of <a class="reference internal" href="hmac.html#module-hmac" title="hmac: Keyed-Hashing for Message Authentication (HMAC) implementation"><code class="xref py py-mod docutils literal"><span class="pre">hmac</span></code></a>. It is about
three times slower and doesn&#8217;t release the GIL.</p>
</div>
</dd></dl>

<div class="admonition seealso">
<p class="first admonition-title">See also</p>
<dl class="last docutils">
<dt>Module <a class="reference internal" href="hmac.html#module-hmac" title="hmac: Keyed-Hashing for Message Authentication (HMAC) implementation"><code class="xref py py-mod docutils literal"><span class="pre">hmac</span></code></a></dt>
<dd>A module to generate message authentication codes using hashes.</dd>
<dt>Module <a class="reference internal" href="base64.html#module-base64" title="base64: RFC 3548: Base16, Base32, Base64 Data Encodings; Base85 and Ascii85"><code class="xref py py-mod docutils literal"><span class="pre">base64</span></code></a></dt>
<dd>Another way to encode binary hashes for non-binary environments.</dd>
<dt><a class="reference external" href="http://csrc.nist.gov/publications/fips/fips180-2/fips180-2.pdf">http://csrc.nist.gov/publications/fips/fips180-2/fips180-2.pdf</a></dt>
<dd>The FIPS 180-2 publication on Secure Hash Algorithms.</dd>
<dt><a class="reference external" href="https://en.wikipedia.org/wiki/Cryptographic_hash_function#Cryptographic_hash_algorithms">https://en.wikipedia.org/wiki/Cryptographic_hash_function#Cryptographic_hash_algorithms</a></dt>
<dd>Wikipedia article with information on which algorithms have known issues and
what that means regarding their use.</dd>
<dt><a class="reference external" href="http://www.ietf.org/rfc/rfc2898.txt">http://www.ietf.org/rfc/rfc2898.txt</a></dt>
<dd>PKCS #5: Password-Based Cryptography Specification Version 2.0</dd>
</dl>
</div>
</div>
</div>


          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
  <h3><a href="../contents.html">Table Of Contents</a></h3>
  <ul>
<li><a class="reference internal" href="#">15.1. <code class="docutils literal"><span class="pre">hashlib</span></code> &#8212; Secure hashes and message digests</a><ul>
<li><a class="reference internal" href="#hash-algorithms">15.1.1. Hash algorithms</a></li>
<li><a class="reference internal" href="#key-derivation">15.1.2. Key derivation</a></li>
</ul>
</li>
</ul>

  <h4>Previous topic</h4>
  <p class="topless"><a href="crypto.html"
                        title="previous chapter">15. Cryptographic Services</a></p>
  <h4>Next topic</h4>
  <p class="topless"><a href="hmac.html"
                        title="next chapter">15.2. <code class="docutils literal"><span class="pre">hmac</span></code> &#8212; Keyed-Hashing for Message Authentication</a></p>
<h3>This Page</h3>
<ul class="this-page-menu">
  <li><a href="../bugs.html">Report a Bug</a></li>
  <li><a href="../_sources/library/hashlib.txt"
         rel="nofollow">Show Source</a></li>
</ul>

<div id="searchbox" style="display: none" role="search">
  <h3>Quick search</h3>
    <form class="search" action="../search.html" method="get">
      <input type="text" name="q" />
      <input type="submit" value="Go" />
      <input type="hidden" name="check_keywords" value="yes" />
      <input type="hidden" name="area" value="default" />
    </form>
    <p class="searchtip" style="font-size: 90%">
    Enter search terms or a module, class or function name.
    </p>
</div>
<script type="text/javascript">$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>  
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             >index</a></li>
        <li class="right" >
          <a href="../py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="right" >
          <a href="hmac.html" title="15.2. hmac — Keyed-Hashing for Message Authentication"
             >next</a> |</li>
        <li class="right" >
          <a href="crypto.html" title="15. Cryptographic Services"
             >previous</a> |</li>
        <li><img src="../_static/py.png" alt=""
                 style="vertical-align: middle; margin-top: -1px"/></li>
        <li><a href="https://www.python.org/">Python</a> &raquo;</li>
        <li>
          <span class="version_switcher_placeholder">3.5.1</span>
          <a href="../index.html">Documentation</a> &raquo;
        </li>

          <li class="nav-item nav-item-1"><a href="index.html" >The Python Standard Library</a> &raquo;</li>
          <li class="nav-item nav-item-2"><a href="crypto.html" >15. Cryptographic Services</a> &raquo;</li> 
      </ul>
    </div>  
    <div class="footer">
    &copy; <a href="../copyright.html">Copyright</a> 1990-2016, Python Software Foundation.
    <br />
    The Python Software Foundation is a non-profit corporation.
    <a href="https://www.python.org/psf/donations/">Please donate.</a>
    <br />
    Last updated on Jan 08, 2016.
    <a href="../bugs.html">Found a bug</a>?
    <br />
    Created using <a href="http://sphinx.pocoo.org/">Sphinx</a> 1.3.3.
    </div>

  </body>
</html>